Corner Fold

SpreadJS supports setting data in the style to create a cell's corner fold.

You can set the corner fold of a cell in the following way: You can find detailed information on the settings below. position: leftTop leftBottom rightTop rightBottom Default Values: size: 6 position: GC.Spread.Sheets.CornerPosition.leftTop color: #FF3D00
window.onload = function () { let spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 1 }); initSpread(spread); }; function initSpread(spread) { let sheet = spread.getSheet(0); initSpreadData(sheet); initSheet(sheet); bindEvents(spread); } function initSheet (sheet) { let style = sheet.getStyle(18, 4); style.decoration = { cornerFold: { size: 8, position: 1, color: "red" } } sheet.setStyle(18, 4, style); style = sheet.getStyle(18, 6); style.decoration = { cornerFold: { size: 10, position: 2, color: "green" } } sheet.setStyle(18, 6, style); style = sheet.getStyle(6, 10); style.decoration = { cornerFold: { size: 15, position: 4, color: "blue" } } sheet.setStyle(6, 10, style); style = sheet.getStyle(12, 10); style.decoration = { cornerFold: { size: 20, position: 8, color: "black" } } sheet.setStyle(12, 10, style); style = sheet.getStyle(18, 10); style.decoration = { cornerFold: { size: 8, position: 15, color: "black" } } sheet.setStyle(18, 10, style); } function initSpreadData(sheet) { let spreadNS = GC.Spread.Sheets; sheet.addSpan(1, 1, 1, 3); sheet.setValue(1, 1, 'Store'); sheet.addSpan(1, 4, 1, 7); sheet.setValue(1, 4, 'Goods'); sheet.addSpan(2, 1, 1, 2); sheet.setValue(2, 1, 'Area'); sheet.addSpan(2, 3, 2, 1); sheet.setValue(2, 3, 'ID'); sheet.addSpan(2, 4, 1, 2); sheet.setValue(2, 4, 'Fruits'); sheet.addSpan(2, 6, 1, 2); sheet.setValue(2, 6, 'Vegetables'); sheet.addSpan(2, 8, 1, 2); sheet.setValue(2, 8, 'Foods'); sheet.addSpan(2, 10, 2, 1); sheet.setValue(2, 10, 'Total'); sheet.setValue(3, 1, 'State'); sheet.setValue(3, 2, 'City'); sheet.setValue(3, 4, 'Grape'); sheet.setValue(3, 5, 'Apple'); sheet.setValue(3, 6, 'Potato'); sheet.setValue(3, 7, 'Tomato'); sheet.setValue(3, 8, 'SandWich'); sheet.setValue(3, 9, 'Hamburger'); sheet.addSpan(4, 1, 7, 1); sheet.addSpan(4, 2, 3, 1); sheet.addSpan(7, 2, 3, 1); sheet.addSpan(10, 2, 1, 2); sheet.setValue(10, 2, 'Sub Total:'); sheet.addSpan(11, 1, 7, 1); sheet.addSpan(11, 2, 3, 1); sheet.addSpan(14, 2, 3, 1); sheet.addSpan(17, 2, 1, 2); sheet.setValue(17, 2, 'Sub Total:'); sheet.addSpan(18, 1, 1, 3); sheet.setValue(18, 1, 'Total:'); sheet.setValue(4, 1, 'NC'); sheet.setValue(4, 2, 'Raleigh'); sheet.setValue(7, 2, 'Charlotte'); sheet.setValue(4, 3, '001'); sheet.setValue(5, 3, '002'); sheet.setValue(6, 3, '003'); sheet.setValue(7, 3, '004'); sheet.setValue(8, 3, '005'); sheet.setValue(9, 3, '006'); sheet.setValue(11, 1, 'PA'); sheet.setValue(11, 2, 'Philadelphia'); sheet.setValue(14, 2, 'Pittsburgh'); sheet.setValue(11, 3, '007'); sheet.setValue(12, 3, '008'); sheet.setValue(13, 3, '009'); sheet.setValue(14, 3, '010'); sheet.setValue(15, 3, '011'); sheet.setValue(16, 3, '012'); sheet.setFormula(10, 4, '=SUM(E5:E10)'); sheet.setFormula(10, 5, '=SUM(F5:F10)'); sheet.setFormula(10, 6, '=SUM(G5:G10)'); sheet.setFormula(10, 7, '=SUM(H5:H10)'); sheet.setFormula(10, 8, '=SUM(I5:I10)'); sheet.setFormula(10, 9, '=SUM(J5:J10)'); sheet.setFormula(17, 4, '=SUM(E12:E17)'); sheet.setFormula(17, 5, '=SUM(F12:F17)'); sheet.setFormula(17, 6, '=SUM(G12:G17)'); sheet.setFormula(17, 7, '=SUM(H12:H17)'); sheet.setFormula(17, 8, '=SUM(I12:I17)'); sheet.setFormula(17, 9, '=SUM(J12:J17)'); for (let i = 0; i < 14; i++) { sheet.setFormula(4 + i, 10, '=SUM(E' + (5 + i).toString() + ':J' + (5 + i).toString() + ')'); } sheet.setFormula(18, 4, '=E11+E18'); sheet.setFormula(18, 5, '=F11+F18'); sheet.setFormula(18, 6, '=G11+G18'); sheet.setFormula(18, 7, '=H11+H18'); sheet.setFormula(18, 8, '=I11+I18'); sheet.setFormula(18, 9, '=J11+J18'); sheet.setFormula(18, 10, '=K11+K18'); sheet.getRange(1, 1, 3, 10).backColor('#D9D9FF'); sheet.getRange(4, 1, 15, 3).backColor('#D9FFD9'); sheet.getRange(1, 1, 3, 10).hAlign(spreadNS.HorizontalAlign.center); sheet.getRange(1, 1, 18, 10).setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.thin), { all: true }); sheet.getRange(4, 4, 3, 6).setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), { inside: true }); sheet.getRange(7, 4, 3, 6).setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), { inside: true }); sheet .getRange(11, 4, 3, 6) .setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), { inside: true }); sheet .getRange(14, 4, 3, 6) .setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), { inside: true }); fillSampleData(sheet, new spreadNS.Range(4, 4, 6, 6)); fillSampleData(sheet, new spreadNS.Range(11, 4, 6, 6)); } function fillSampleData(sheet, range) { for (let i = 0; i < range.rowCount; i++) { for (let j = 0; j < range.colCount; j++) { sheet.setValue(range.row + i, range.col + j, Math.ceil(Math.random() * 300)); } } } function bindEvents (spread) { let sheet = spread.getSheet(0); document.getElementById("set-corner").addEventListener('click', function () { set(sheet); sheet.repaint(); }); document.getElementById("reset-corner").addEventListener('click', function () { reset(sheet); sheet.repaint(); }); spread.bind(GC.Spread.Sheets.Events.SelectionChanged, function () { reset(sheet); sheet.repaint(); }); } function reset (sheet) { let activeRow = sheet.getActiveRowIndex(); let activeCol = sheet.getActiveColumnIndex(); let style = sheet.getStyle(activeRow, activeCol); document.getElementById('leftTop').checked = false; document.getElementById('leftBottom').checked = false; document.getElementById('rightTop').checked = false; document.getElementById('rightBottom').checked = false; if (style && style.decoration && style.decoration.cornerFold) { let cornerFold = style.decoration.cornerFold; document.getElementById('size-corner').value = +cornerFold.size; document.getElementById('color-corner').value = cornerFold.color; if (cornerFold.position & 1) { document.getElementById('leftTop').checked = true; } if (cornerFold.position & 2) { document.getElementById('rightTop').checked = true; } if (cornerFold.position & 4) { document.getElementById('leftBottom').checked = true; } if (cornerFold.position & 8) { document.getElementById('rightBottom').checked = true; } } else { document.getElementById('size-corner').value = 6; document.getElementById('color-corner').value = null; } } function set (sheet) { let activeRow = sheet.getActiveRowIndex(); let activeCol = sheet.getActiveColumnIndex(); let style = sheet.getStyle(activeRow, activeCol); if (!style) { style = new GC.Spread.Sheets.Style(); } let position = 0; if (document.getElementById('leftTop').checked) { position = position | 1; } if (document.getElementById('rightTop').checked) { position = position | 2; } if (document.getElementById('leftBottom').checked) { position = position | 4; } if (document.getElementById('rightBottom').checked) { position = position | 8; } style.decoration = { cornerFold: { size: +document.getElementById('size-corner').value, position: position, color: document.getElementById('color-corner').value } } sheet.setStyle(activeRow, activeCol, style); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> <p>Try selecting a cell, change the following options and hit the "reset" button.</p> <div class="corner-pro"> <label for="size-corner">corner size:</label><input type="number" id="size-corner" class="corner-input" placeholder="corner-size" value="6"> </div> <div class="corner-pro"> <label for="color-corner">corner color:</label><input type="text" id="color-corner" class="corner-input" placeholder="corner-color"> </div> <div class="corner-pro"> <label for="position-corner">leftTop position:</label><input type="checkbox" class="corner-input" id="leftTop"> </div> <div class="corner-pro"> <label for="position-corner">rightTop position:</label><input type="checkbox" class="corner-input" id="rightTop"> </div> <div class="corner-pro"> <label for="position-corner">leftBottom position:</label><input type="checkbox" class="corner-input" id="leftBottom"> </div> <div class="corner-pro"> <label for="position-corner">rightBottom position:</label><input type="checkbox" class="corner-input" id="rightBottom"> </div> <div class="corner-pro"> <button id="set-corner" class="corner-btn">set</button> <button id="reset-corner" class="corner-btn">reset</button> </div> </div> </div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } label { display: inline-block; width: 135px; } .corner-pro { width: 100%; height: 30px; font-size: 13px; } #size-corner, #color-corner { display: inline-block; width: 100px; } .corner-btn { display: inline-block; width: 100px; height: 30px; margin-left: 20px; }

You can set the corner fold of a cell in the following way:
You can find detailed information on the settings below.
position:
leftTop
leftBottom
rightTop
rightBottom
Default Values:
size: 6
position: GC.Spread.Sheets.CornerPosition.leftTop
color: #FF3D00
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
let spread = null;
export function AppFunc() {
const [cornerFolderOption, setCornerFolderOption] = React.useState({
size: 6,
color: "red",
leftTop: false,
leftBottom: false,
rightTop: false,
rightBottom: false,
});
const handleInputClick = (event) => {
const target = event.target;
const value = target.checked;
const name = target.name;
setCornerFolderOption({ ...cornerFolderOption, [name]: value });
}
const handleInputChange = (event) => {
const target = event.target;
const value = target.value;
const name = target.name;
setCornerFolderOption({ ...cornerFolderOption, [name]: value });
}
const initSpread = (currSpread) => {
spread = currSpread;
let sheet = spread.getSheet(0);
initSpreadData(sheet);
initSheet(sheet);
bindEvents(spread);
}
const initSheet = (sheet) => {
let style = sheet.getStyle(18, 4);
style.decoration = {
cornerFold: {
size: 8,
position: 1,
color: "red"
}
}
sheet.setStyle(18, 4, style);
style = sheet.getStyle(18, 6);
style.decoration = {
cornerFold: {
size: 10,
position: 2,
color: "green"
}
}
sheet.setStyle(18, 6, style);
style = sheet.getStyle(6, 10);
style.decoration = {
cornerFold: {
size: 15,
position: 4,
color: "blue"
}
}
sheet.setStyle(6, 10, style);
style = sheet.getStyle(12, 10);
style.decoration = {
cornerFold: {
size: 20,
position: 8,
color: "black"
}
}
sheet.setStyle(12, 10, style);
style = sheet.getStyle(18, 10);
style.decoration = {
cornerFold: {
size: 8,
position: 15,
color: "black"
}
}
sheet.setStyle(18, 10, style);
}
const initSpreadData = (sheet) => {
let spreadNS = GC.Spread.Sheets;
sheet.addSpan(1, 1, 1, 3);
sheet.setValue(1, 1, 'Store');
sheet.addSpan(1, 4, 1, 7);
sheet.setValue(1, 4, 'Goods');
sheet.addSpan(2, 1, 1, 2);
sheet.setValue(2, 1, 'Area');
sheet.addSpan(2, 3, 2, 1);
sheet.setValue(2, 3, 'ID');
sheet.addSpan(2, 4, 1, 2);
sheet.setValue(2, 4, 'Fruits');
sheet.addSpan(2, 6, 1, 2);
sheet.setValue(2, 6, 'Vegetables');
sheet.addSpan(2, 8, 1, 2);
sheet.setValue(2, 8, 'Foods');
sheet.addSpan(2, 10, 2, 1);
sheet.setValue(2, 10, 'Total');
sheet.setValue(3, 1, 'State');
sheet.setValue(3, 2, 'City');
sheet.setValue(3, 4, 'Grape');
sheet.setValue(3, 5, 'Apple');
sheet.setValue(3, 6, 'Potato');
sheet.setValue(3, 7, 'Tomato');
sheet.setValue(3, 8, 'SandWich');
sheet.setValue(3, 9, 'Hamburger');
sheet.addSpan(4, 1, 7, 1);
sheet.addSpan(4, 2, 3, 1);
sheet.addSpan(7, 2, 3, 1);
sheet.addSpan(10, 2, 1, 2);
sheet.setValue(10, 2, 'Sub Total:');
sheet.addSpan(11, 1, 7, 1);
sheet.addSpan(11, 2, 3, 1);
sheet.addSpan(14, 2, 3, 1);
sheet.addSpan(17, 2, 1, 2);
sheet.setValue(17, 2, 'Sub Total:');
sheet.addSpan(18, 1, 1, 3);
sheet.setValue(18, 1, 'Total:');
sheet.setValue(4, 1, 'NC');
sheet.setValue(4, 2, 'Raleigh');
sheet.setValue(7, 2, 'Charlotte');
sheet.setValue(4, 3, '001');
sheet.setValue(5, 3, '002');
sheet.setValue(6, 3, '003');
sheet.setValue(7, 3, '004');
sheet.setValue(8, 3, '005');
sheet.setValue(9, 3, '006');
sheet.setValue(11, 1, 'PA');
sheet.setValue(11, 2, 'Philadelphia');
sheet.setValue(14, 2, 'Pittsburgh');
sheet.setValue(11, 3, '007');
sheet.setValue(12, 3, '008');
sheet.setValue(13, 3, '009');
sheet.setValue(14, 3, '010');
sheet.setValue(15, 3, '011');
sheet.setValue(16, 3, '012');
sheet.setFormula(10, 4, '=SUM(E5:E10)');
sheet.setFormula(10, 5, '=SUM(F5:F10)');
sheet.setFormula(10, 6, '=SUM(G5:G10)');
sheet.setFormula(10, 7, '=SUM(H5:H10)');
sheet.setFormula(10, 8, '=SUM(I5:I10)');
sheet.setFormula(10, 9, '=SUM(J5:J10)');
sheet.setFormula(17, 4, '=SUM(E12:E17)');
sheet.setFormula(17, 5, '=SUM(F12:F17)');
sheet.setFormula(17, 6, '=SUM(G12:G17)');
sheet.setFormula(17, 7, '=SUM(H12:H17)');
sheet.setFormula(17, 8, '=SUM(I12:I17)');
sheet.setFormula(17, 9, '=SUM(J12:J17)');
for (let i = 0; i < 14; i++) {
sheet.setFormula(4 + i, 10, '=SUM(E' + (5 + i).toString() + ':J' + (5 + i).toString() + ')');
}
sheet.setFormula(18, 4, '=E11+E18');
sheet.setFormula(18, 5, '=F11+F18');
sheet.setFormula(18, 6, '=G11+G18');
sheet.setFormula(18, 7, '=H11+H18');
sheet.setFormula(18, 8, '=I11+I18');
sheet.setFormula(18, 9, '=J11+J18');
sheet.setFormula(18, 10, '=K11+K18');
sheet.getRange(1, 1, 3, 10).backColor('#D9D9FF');
sheet.getRange(4, 1, 15, 3).backColor('#D9FFD9');
sheet.getRange(1, 1, 3, 10).hAlign(spreadNS.HorizontalAlign.center);
sheet.getRange(1, 1, 18, 10).setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.thin), { all: true });
sheet.getRange(4, 4, 3, 6).setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), { inside: true });
sheet.getRange(7, 4, 3, 6).setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), { inside: true });
sheet
.getRange(11, 4, 3, 6)
.setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), { inside: true });
sheet
.getRange(14, 4, 3, 6)
.setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), { inside: true });
fillSampleData(sheet, new spreadNS.Range(4, 4, 6, 6));
fillSampleData(sheet, new spreadNS.Range(11, 4, 6, 6));
}
const fillSampleData = (sheet, range) => {
for (let i = 0; i < range.rowCount; i++) {
for (let j = 0; j < range.colCount; j++) {
sheet.setValue(range.row + i, range.col + j, Math.ceil(Math.random() * 300));
}
}
}
const bindEvents = (spread) => {
let sheet = spread.getSheet(0);
spread.bind(GC.Spread.Sheets.Events.SelectionChanged, function () {
reset(sheet);
sheet.repaint();
});
}
const reset = ()=> {
let sheet = spread.getActiveSheet();
let activeRow = sheet.getActiveRowIndex();
let activeCol = sheet.getActiveColumnIndex();
let style = sheet.getStyle(activeRow, activeCol);
let state = { ...cornerFolderOption };
state.leftTop = false;
state.rightTop = false;
state.leftBottom = false;
state.rightBottom = false;
if (style && style.decoration && style.decoration.cornerFold) {
let cornerFold = style.decoration.cornerFold;
state.size = +cornerFold.size;
state.color = cornerFold.color;
if (cornerFold.position & 1) {
state.leftTop = true;
}
if (cornerFold.position & 2) {
state.rightTop = true;
}
if (cornerFold.position & 4) {
state.leftBottom = true;
}
if (cornerFold.position & 8) {
state.rightBottom = true;
}
} else {
state.size = 6;
state.color = '';
}
setCornerFolderOption(state);
}
const set = () => {
let sheet = spread.getActiveSheet();
let activeRow = sheet.getActiveRowIndex();
let activeCol = sheet.getActiveColumnIndex();
let style = sheet.getStyle(activeRow, activeCol);
let state = { ...cornerFolderOption };
if (!style) {
style = new GC.Spread.Sheets.Style();
}
let position = 0;
if (state.leftTop) {
position = position | 1;
}
if (state.rightTop) {
position = position | 2;
}
if (state.leftBottom) {
position = position | 4;
}
if (state.rightBottom) {
position = position | 8;
}
style.decoration = {
cornerFold: {
size: state.size,
position: position,
color: state.color
}
}
sheet.setStyle(activeRow, activeCol, style);
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={initSpread} />
</div>
<div class="options-container">
<p>Try selecting a cell, change the following options and hit the "reset" button.</p>
<div class="corner-pro">
<label for="size-corner">corner size:</label><input type="number" id="size-corner" name={'size'} class="corner-input" placeholder="corner-size" value={cornerFolderOption.size} onChange={handleInputChange}/>
</div>
<div class="corner-pro">
<label for="color-corner">corner color:</label><input type="text" id="color-corner" name={'color'} class="corner-input" placeholder="corner-color" value={cornerFolderOption.color} onChange={handleInputChange}/>
</div>
<div class="corner-pro">
<label for="position-corner">leftTop position:</label><input type="checkbox" name={'leftTop'} class="corner-input" id="leftTop" checked={cornerFolderOption.leftTop} onChange={handleInputClick}/>
</div>
<div class="corner-pro">
<label for="position-corner">rightTop position:</label><input type="checkbox" name={'rightTop'} class="corner-input" id="rightTop" checked={cornerFolderOption.rightTop} onChange={handleInputClick}/>
</div>
<div class="corner-pro">
<label for="position-corner">leftBottom position:</label><input type="checkbox" name={'leftBottom'} class="corner-input" id="leftBottom" checked={cornerFolderOption.leftBottom} onChange={handleInputClick}/>
</div>
<div class="corner-pro">
<label for="position-corner">rightBottom position:</label><input type="checkbox" name={'rightBottom'} class="corner-input" id="rightBottom" checked={cornerFolderOption.rightBottom} onChange={handleInputClick}/>
</div>
<div class="corner-pro">
<button id="set-corner" class="corner-btn" onClick={set}>set</button>
<button id="reset-corner" class="corner-btn" onClick={reset}>reset</button>
</div>
</div>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.state = {
size: 6,
color: "red",
leftTop: false,
leftBottom: false,
rightTop: false,
rightBottom: false,
}
}
handleInputClick = (event) => {
const target = event.target;
const value = target.checked;
const name = target.name;
this.setState({
[name]: value
});
}
handleInputChange = (event) => {
const target = event.target;
const value = target.value;
const name = target.name;
this.setState({
[name]: value
});
}
initSpread = (spread) => {
this.spread = spread;
let sheet = spread.getSheet(0);
this.initSpreadData(sheet);
this.initSheet(sheet);
this.bindEvents(spread);
}
initSheet = (sheet) => {
let style = sheet.getStyle(18, 4);
style.decoration = {
cornerFold: {
size: 8,
position: 1,
color: "red"
}
}
sheet.setStyle(18, 4, style);
style = sheet.getStyle(18, 6);
style.decoration = {
cornerFold: {
size: 10,
position: 2,
color: "green"
}
}
sheet.setStyle(18, 6, style);
style = sheet.getStyle(6, 10);
style.decoration = {
cornerFold: {
size: 15,
position: 4,
color: "blue"
}
}
sheet.setStyle(6, 10, style);
style = sheet.getStyle(12, 10);
style.decoration = {
cornerFold: {
size: 20,
position: 8,
color: "black"
}
}
sheet.setStyle(12, 10, style);
style = sheet.getStyle(18, 10);
style.decoration = {
cornerFold: {
size: 8,
position: 15,
color: "black"
}
}
sheet.setStyle(18, 10, style);
}
initSpreadData = (sheet) => {
let spreadNS = GC.Spread.Sheets;
sheet.addSpan(1, 1, 1, 3);
sheet.setValue(1, 1, 'Store');
sheet.addSpan(1, 4, 1, 7);
sheet.setValue(1, 4, 'Goods');
sheet.addSpan(2, 1, 1, 2);
sheet.setValue(2, 1, 'Area');
sheet.addSpan(2, 3, 2, 1);
sheet.setValue(2, 3, 'ID');
sheet.addSpan(2, 4, 1, 2);
sheet.setValue(2, 4, 'Fruits');
sheet.addSpan(2, 6, 1, 2);
sheet.setValue(2, 6, 'Vegetables');
sheet.addSpan(2, 8, 1, 2);
sheet.setValue(2, 8, 'Foods');
sheet.addSpan(2, 10, 2, 1);
sheet.setValue(2, 10, 'Total');
sheet.setValue(3, 1, 'State');
sheet.setValue(3, 2, 'City');
sheet.setValue(3, 4, 'Grape');
sheet.setValue(3, 5, 'Apple');
sheet.setValue(3, 6, 'Potato');
sheet.setValue(3, 7, 'Tomato');
sheet.setValue(3, 8, 'SandWich');
sheet.setValue(3, 9, 'Hamburger');
sheet.addSpan(4, 1, 7, 1);
sheet.addSpan(4, 2, 3, 1);
sheet.addSpan(7, 2, 3, 1);
sheet.addSpan(10, 2, 1, 2);
sheet.setValue(10, 2, 'Sub Total:');
sheet.addSpan(11, 1, 7, 1);
sheet.addSpan(11, 2, 3, 1);
sheet.addSpan(14, 2, 3, 1);
sheet.addSpan(17, 2, 1, 2);
sheet.setValue(17, 2, 'Sub Total:');
sheet.addSpan(18, 1, 1, 3);
sheet.setValue(18, 1, 'Total:');
sheet.setValue(4, 1, 'NC');
sheet.setValue(4, 2, 'Raleigh');
sheet.setValue(7, 2, 'Charlotte');
sheet.setValue(4, 3, '001');
sheet.setValue(5, 3, '002');
sheet.setValue(6, 3, '003');
sheet.setValue(7, 3, '004');
sheet.setValue(8, 3, '005');
sheet.setValue(9, 3, '006');
sheet.setValue(11, 1, 'PA');
sheet.setValue(11, 2, 'Philadelphia');
sheet.setValue(14, 2, 'Pittsburgh');
sheet.setValue(11, 3, '007');
sheet.setValue(12, 3, '008');
sheet.setValue(13, 3, '009');
sheet.setValue(14, 3, '010');
sheet.setValue(15, 3, '011');
sheet.setValue(16, 3, '012');
sheet.setFormula(10, 4, '=SUM(E5:E10)');
sheet.setFormula(10, 5, '=SUM(F5:F10)');
sheet.setFormula(10, 6, '=SUM(G5:G10)');
sheet.setFormula(10, 7, '=SUM(H5:H10)');
sheet.setFormula(10, 8, '=SUM(I5:I10)');
sheet.setFormula(10, 9, '=SUM(J5:J10)');
sheet.setFormula(17, 4, '=SUM(E12:E17)');
sheet.setFormula(17, 5, '=SUM(F12:F17)');
sheet.setFormula(17, 6, '=SUM(G12:G17)');
sheet.setFormula(17, 7, '=SUM(H12:H17)');
sheet.setFormula(17, 8, '=SUM(I12:I17)');
sheet.setFormula(17, 9, '=SUM(J12:J17)');
for (let i = 0; i < 14; i++) {
sheet.setFormula(4 + i, 10, '=SUM(E' + (5 + i).toString() + ':J' + (5 + i).toString() + ')');
}
sheet.setFormula(18, 4, '=E11+E18');
sheet.setFormula(18, 5, '=F11+F18');
sheet.setFormula(18, 6, '=G11+G18');
sheet.setFormula(18, 7, '=H11+H18');
sheet.setFormula(18, 8, '=I11+I18');
sheet.setFormula(18, 9, '=J11+J18');
sheet.setFormula(18, 10, '=K11+K18');
sheet.getRange(1, 1, 3, 10).backColor('#D9D9FF');
sheet.getRange(4, 1, 15, 3).backColor('#D9FFD9');
sheet.getRange(1, 1, 3, 10).hAlign(spreadNS.HorizontalAlign.center);
sheet.getRange(1, 1, 18, 10).setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.thin), { all: true });
sheet.getRange(4, 4, 3, 6).setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), { inside: true });
sheet.getRange(7, 4, 3, 6).setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), { inside: true });
sheet
.getRange(11, 4, 3, 6)
.setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), { inside: true });
sheet
.getRange(14, 4, 3, 6)
.setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), { inside: true });
this.fillSampleData(sheet, new spreadNS.Range(4, 4, 6, 6));
this.fillSampleData(sheet, new spreadNS.Range(11, 4, 6, 6));
}
fillSampleData = (sheet, range) => {
for (let i = 0; i < range.rowCount; i++) {
for (let j = 0; j < range.colCount; j++) {
sheet.setValue(range.row + i, range.col + j, Math.ceil(Math.random() * 300));
}
}
}
bindEvents = (spread) => {
let sheet = spread.getSheet(0), self = this;
spread.bind(GC.Spread.Sheets.Events.SelectionChanged, function () {
self.reset(sheet);
sheet.repaint();
});
}
reset = ()=> {
let sheet = this.spread.getActiveSheet();
let activeRow = sheet.getActiveRowIndex();
let activeCol = sheet.getActiveColumnIndex();
let style = sheet.getStyle(activeRow, activeCol);
let state = this.state;
state.leftTop = false;
state.rightTop = false;
state.leftBottom = false;
state.rightBottom = false;
if (style && style.decoration && style.decoration.cornerFold) {
let cornerFold = style.decoration.cornerFold;
state.size = +cornerFold.size;
state.color = cornerFold.color;
if (cornerFold.position & 1) {
state.leftTop = true;
}
if (cornerFold.position & 2) {
state.rightTop = true;
}
if (cornerFold.position & 4) {
state.leftBottom = true;
}
if (cornerFold.position & 8) {
state.rightBottom = true;
}
} else {
state.size = 6;
state.color = '';
}
this.setState(state);
}
set = () => {
let sheet = this.spread.getActiveSheet();
let activeRow = sheet.getActiveRowIndex();
let activeCol = sheet.getActiveColumnIndex();
let style = sheet.getStyle(activeRow, activeCol);
let state = this.state;
if (!style) {
style = new GC.Spread.Sheets.Style();
}
let position = 0;
if (state.leftTop) {
position = position | 1;
}
if (state.rightTop) {
position = position | 2;
}
if (state.leftBottom) {
position = position | 4;
}
if (state.rightBottom) {
position = position | 8;
}
style.decoration = {
cornerFold: {
size: state.size,
position: position,
color: state.color
}
}
sheet.setStyle(activeRow, activeCol, style);
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={this.initSpread} />
</div>
<div class="options-container">
<p>Try selecting a cell, change the following options and hit the "reset" button.</p>
<div class="corner-pro">
<label for="size-corner">corner size:</label><input type="number" id="size-corner" name={'size'} class="corner-input" placeholder="corner-size" value={this.state.size} onChange={this.handleInputChange}/>
</div>
<div class="corner-pro">
<label for="color-corner">corner color:</label><input type="text" id="color-corner" name={'color'} class="corner-input" placeholder="corner-color" value={this.state.color} onChange={this.handleInputChange}/>
</div>
<div class="corner-pro">
<label for="position-corner">leftTop position:</label><input type="checkbox" name={'leftTop'} class="corner-input" id="leftTop" checked={this.state.leftTop} onChange={this.handleInputClick}/>
</div>
<div class="corner-pro">
<label for="position-corner">rightTop position:</label><input type="checkbox" name={'rightTop'} class="corner-input" id="rightTop" checked={this.state.rightTop} onChange={this.handleInputClick}/>
</div>
<div class="corner-pro">
<label for="position-corner">leftBottom position:</label><input type="checkbox" name={'leftBottom'} class="corner-input" id="leftBottom" checked={this.state.leftBottom} onChange={this.handleInputClick}/>
</div>
<div class="corner-pro">
<label for="position-corner">rightBottom position:</label><input type="checkbox" name={'rightBottom'} class="corner-input" id="rightBottom" checked={this.state.rightBottom} onChange={this.handleInputClick}/>
</div>
<div class="corner-pro">
<button id="set-corner" class="corner-btn" onClick={this.set}>set</button>
<button id="reset-corner" class="corner-btn" onClick={this.reset}>reset</button>
</div>
</div>
</div>
)
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
label {
display: inline-block;
width: 135px;
}
.corner-pro {
width: 100%;
height: 30px;
font-size: 13px;
}
#size-corner, #color-corner {
display: inline-block;
width: 100px;
}
.corner-btn {
display: inline-block;
width: 100px;
height: 30px;
margin-left: 20px;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

You can set the corner fold of a cell in the following way:
You can find detailed information on the settings below.
position:
leftTop
leftBottom
rightTop
rightBottom
Default Values:
size: 6
position: GC.Spread.Sheets.CornerPosition.leftTop
color: #FF3D00
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbook-initialized="initSpread"></gc-spread-sheets>
<div class="options-container">
<p>Try selecting a cell, change the following options and hit the "reset" button.</p>
<div class="corner-pro">
<label for="size-corner">corner size:</label><input type="number" id="size-corner" class="corner-input"
placeholder="corner-size" v-model="size">
</div>
<div class="corner-pro">
<label for="color-corner">corner color:</label><input type="text" id="color-corner" class="corner-input"
placeholder="corner-color" v-model="color">
</div>
<div class="corner-pro">
<label for="position-corner">leftTop position:</label><input type="checkbox" class="corner-input"
id="leftTop" v-model="leftTop">
</div>
<div class="corner-pro">
<label for="position-corner">rightTop position:</label><input type="checkbox" class="corner-input"
id="rightTop" v-model="rightTop">
</div>
<div class="corner-pro">
<label for="position-corner">leftBottom position:</label><input type="checkbox" class="corner-input"
id="leftBottom" v-model="leftBottom">
</div>
<div class="corner-pro">
<label for="position-corner">rightBottom position:</label><input type="checkbox" class="corner-input"
id="rightBottom" v-model="rightBottom">
</div>
<div class="corner-pro">
<button id="set-corner" class="corner-btn" @click="set">set</button>
<button id="reset-corner" class="corner-btn" @click="reset">reset</button>
</div>
</div>
</div>
</template>
<script setup>
import { ref } from 'vue';
import '@mescius/spread-sheets-vue';
import GC from '@mescius/spread-sheets';
const size = ref(6);
const color = ref("red");
const leftTop = ref(false);
const leftBottom = ref(false);
const rightTop = ref(false);
const rightBottom = ref(false);
const spread = ref(null);
const initSpread = (spreadInstance) => {
spread.value = spreadInstance;
const sheet = spreadInstance.getSheet(0);
initSpreadData(sheet);
initSheet(sheet);
bindEvents(spreadInstance);
};
const initSheet = (sheet) => {
let style = sheet.getStyle(18, 4);
style.decoration = {
cornerFold: {
size: 8,
position: 1,
color: "red"
}
};
sheet.setStyle(18, 4, style);
style = sheet.getStyle(18, 6);
style.decoration = {
cornerFold: {
size: 10,
position: 2,
color: "green"
}
};
sheet.setStyle(18, 6, style);
style = sheet.getStyle(6, 10);
style.decoration = {
cornerFold: {
size: 15,
position: 4,
color: "blue"
}
};
sheet.setStyle(6, 10, style);
style = sheet.getStyle(12, 10);
style.decoration = {
cornerFold: {
size: 20,
position: 8,
color: "black"
}
};
sheet.setStyle(12, 10, style);
style = sheet.getStyle(18, 10);
style.decoration = {
cornerFold: {
size: 8,
position: 15,
color: "black"
}
};
sheet.setStyle(18, 10, style);
};
const initSpreadData = (sheet) => {
const spreadNS = GC.Spread.Sheets;
sheet.addSpan(1, 1, 1, 3);
sheet.setValue(1, 1, 'Store');
sheet.addSpan(1, 4, 1, 7);
sheet.setValue(1, 4, 'Goods');
sheet.addSpan(2, 1, 1, 2);
sheet.setValue(2, 1, 'Area');
sheet.addSpan(2, 3, 2, 1);
sheet.setValue(2, 3, 'ID');
sheet.addSpan(2, 4, 1, 2);
sheet.setValue(2, 4, 'Fruits');
sheet.addSpan(2, 6, 1, 2);
sheet.setValue(2, 6, 'Vegetables');
sheet.addSpan(2, 8, 1, 2);
sheet.setValue(2, 8, 'Foods');
sheet.addSpan(2, 10, 2, 1);
sheet.setValue(2, 10, 'Total');
sheet.setValue(3, 1, 'State');
sheet.setValue(3, 2, 'City');
sheet.setValue(3, 4, 'Grape');
sheet.setValue(3, 5, 'Apple');
sheet.setValue(3, 6, 'Potato');
sheet.setValue(3, 7, 'Tomato');
sheet.setValue(3, 8, 'SandWich');
sheet.setValue(3, 9, 'Hamburger');
sheet.addSpan(4, 1, 7, 1);
sheet.addSpan(4, 2, 3, 1);
sheet.addSpan(7, 2, 3, 1);
sheet.addSpan(10, 2, 1, 2);
sheet.setValue(10, 2, 'Sub Total:');
sheet.addSpan(11, 1, 7, 1);
sheet.addSpan(11, 2, 3, 1);
sheet.addSpan(14, 2, 3, 1);
sheet.addSpan(17, 2, 1, 2);
sheet.setValue(17, 2, 'Sub Total:');
sheet.addSpan(18, 1, 1, 3);
sheet.setValue(18, 1, 'Total:');
sheet.setValue(4, 1, 'NC');
sheet.setValue(4, 2, 'Raleigh');
sheet.setValue(7, 2, 'Charlotte');
sheet.setValue(4, 3, '001');
sheet.setValue(5, 3, '002');
sheet.setValue(6, 3, '003');
sheet.setValue(7, 3, '004');
sheet.setValue(8, 3, '005');
sheet.setValue(9, 3, '006');
sheet.setValue(11, 1, 'PA');
sheet.setValue(11, 2, 'Philadelphia');
sheet.setValue(14, 2, 'Pittsburgh');
sheet.setValue(11, 3, '007');
sheet.setValue(12, 3, '008');
sheet.setValue(13, 3, '009');
sheet.setValue(14, 3, '010');
sheet.setValue(15, 3, '011');
sheet.setValue(16, 3, '012');
sheet.setFormula(10, 4, '=SUM(E5:E10)');
sheet.setFormula(10, 5, '=SUM(F5:F10)');
sheet.setFormula(10, 6, '=SUM(G5:G10)');
sheet.setFormula(10, 7, '=SUM(H5:H10)');
sheet.setFormula(10, 8, '=SUM(I5:I10)');
sheet.setFormula(10, 9, '=SUM(J5:J10)');
sheet.setFormula(17, 4, '=SUM(E12:E17)');
sheet.setFormula(17, 5, '=SUM(F12:F17)');
sheet.setFormula(17, 6, '=SUM(G12:G17)');
sheet.setFormula(17, 7, '=SUM(H12:H17)');
sheet.setFormula(17, 8, '=SUM(I12:I17)');
sheet.setFormula(17, 9, '=SUM(J12:J17)');
for (let i = 0; i < 14; i++) {
sheet.setFormula(4 + i, 10, '=SUM(E' + (5 + i).toString() + ':J' + (5 + i).toString() + ')');
}
sheet.setFormula(18, 4, '=E11+E18');
sheet.setFormula(18, 5, '=F11+F18');
sheet.setFormula(18, 6, '=G11+G18');
sheet.setFormula(18, 7, '=H11+H18');
sheet.setFormula(18, 8, '=I11+I18');
sheet.setFormula(18, 9, '=J11+J18');
sheet.setFormula(18, 10, '=K11+K18');
sheet.getRange(1, 1, 3, 10).backColor('#D9D9FF');
sheet.getRange(4, 1, 15, 3).backColor('#D9FFD9');
sheet.getRange(1, 1, 3, 10).hAlign(spreadNS.HorizontalAlign.center);
sheet.getRange(1, 1, 18, 10).setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.thin), { all: true });
sheet.getRange(4, 4, 3, 6).setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), { inside: true });
sheet.getRange(7, 4, 3, 6).setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), { inside: true });
sheet.getRange(11, 4, 3, 6).setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), { inside: true });
sheet.getRange(14, 4, 3, 6).setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), { inside: true });
fillSampleData(sheet, new spreadNS.Range(4, 4, 6, 6));
fillSampleData(sheet, new spreadNS.Range(11, 4, 6, 6));
};
const fillSampleData = (sheet, range) => {
for (let i = 0; i < range.rowCount; i++) {
for (let j = 0; j < range.colCount; j++) {
sheet.setValue(range.row + i, range.col + j, Math.ceil(Math.random() * 300));
}
}
};
const bindEvents = (spreadInstance) => {
const sheet = spreadInstance.getSheet(0);
spreadInstance.bind(GC.Spread.Sheets.Events.SelectionChanged, () => {
reset();
sheet.repaint();
});
};
const reset = () => {
const sheet = spread.value.getActiveSheet();
const activeRow = sheet.getActiveRowIndex();
const activeCol = sheet.getActiveColumnIndex();
const style = sheet.getStyle(activeRow, activeCol);
leftTop.value = false;
rightTop.value = false;
leftBottom.value = false;
rightBottom.value = false;
if (style && style.decoration && style.decoration.cornerFold) {
const cornerFold = style.decoration.cornerFold;
size.value = +cornerFold.size;
color.value = cornerFold.color;
if (cornerFold.position & 1) {
leftTop.value = true;
}
if (cornerFold.position & 2) {
rightTop.value = true;
}
if (cornerFold.position & 4) {
leftBottom.value = true;
}
if (cornerFold.position & 8) {
rightBottom.value = true;
}
} else {
size.value = 6;
color.value = null;
}
};
const set = () => {
const sheet = spread.value.getActiveSheet();
const activeRow = sheet.getActiveRowIndex();
const activeCol = sheet.getActiveColumnIndex();
let style = sheet.getStyle(activeRow, activeCol);
if (!style) {
style = new GC.Spread.Sheets.Style();
}
let position = 0;
if (leftTop.value) {
position = position | 1;
}
if (rightTop.value) {
position = position | 2;
}
if (leftBottom.value) {
position = position | 4;
}
if (rightBottom.value) {
position = position | 8;
}
style.decoration = {
cornerFold: {
size: size.value,
position: position,
color: color.value
}
};
sheet.setStyle(activeRow, activeCol, style);
};
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
label {
display: inline-block;
width: 135px;
}
.corner-pro {
width: 100%;
height: 30px;
font-size: 13px;
}
#size-corner,
#color-corner {
display: inline-block;
width: 100px;
}
.corner-btn {
display: inline-block;
width: 100px;
height: 30px;
margin-left: 20px;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script src="compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

You can set the corner fold of a cell in the following way:
You can find detailed information on the settings below.
position:
leftTop
leftBottom
rightTop
rightBottom
Default Values:
size: 6
position: GC.Spread.Sheets.CornerPosition.leftTop
color: #FF3D00
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import { FormsModule } from '@angular/forms';
import GC from '@mescius/spread-sheets';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
size = 8;
color = 'red';
leftTop = false;
rightTop = false;
leftBottom = false;
rightBottom = false;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
initSpread($event: any) {
let spread = $event.spread;
this.spread = spread;
let sheet = spread.getSheet(0);
this.initSpreadData(sheet);
this.initSheet(sheet);
this.bindEvents(spread);
}
initSheet (sheet: GC.Spread.Sheets.Worksheet) {
let style = sheet.getStyle(18, 4);
style.decoration = {
cornerFold: {
size: 8,
position: 1,
color: "red"
}
}
sheet.setStyle(18, 4, style);
style = sheet.getStyle(18, 6);
style.decoration = {
cornerFold: {
size: 10,
position: 2,
color: "green"
}
}
sheet.setStyle(18, 6, style);
style = sheet.getStyle(6, 10);
style.decoration = {
cornerFold: {
size: 15,
position: 4,
color: "blue"
}
}
sheet.setStyle(6, 10, style);
style = sheet.getStyle(12, 10);
style.decoration = {
cornerFold: {
size: 20,
position: 8,
color: "black"
}
}
sheet.setStyle(12, 10, style);
style = sheet.getStyle(18, 10);
style.decoration = {
cornerFold: {
size: 8,
position: 15,
color: "black"
}
}
sheet.setStyle(18, 10, style);
}
initSpreadData(sheet: GC.Spread.Sheets.Worksheet) {
let spreadNS = GC.Spread.Sheets;
sheet.addSpan(1, 1, 1, 3);
sheet.setValue(1, 1, 'Store');
sheet.addSpan(1, 4, 1, 7);
sheet.setValue(1, 4, 'Goods');
sheet.addSpan(2, 1, 1, 2);
sheet.setValue(2, 1, 'Area');
sheet.addSpan(2, 3, 2, 1);
sheet.setValue(2, 3, 'ID');
sheet.addSpan(2, 4, 1, 2);
sheet.setValue(2, 4, 'Fruits');
sheet.addSpan(2, 6, 1, 2);
sheet.setValue(2, 6, 'Vegetables');
sheet.addSpan(2, 8, 1, 2);
sheet.setValue(2, 8, 'Foods');
sheet.addSpan(2, 10, 2, 1);
sheet.setValue(2, 10, 'Total');
sheet.setValue(3, 1, 'State');
sheet.setValue(3, 2, 'City');
sheet.setValue(3, 4, 'Grape');
sheet.setValue(3, 5, 'Apple');
sheet.setValue(3, 6, 'Potato');
sheet.setValue(3, 7, 'Tomato');
sheet.setValue(3, 8, 'SandWich');
sheet.setValue(3, 9, 'Hamburger');
sheet.addSpan(4, 1, 7, 1);
sheet.addSpan(4, 2, 3, 1);
sheet.addSpan(7, 2, 3, 1);
sheet.addSpan(10, 2, 1, 2);
sheet.setValue(10, 2, 'Sub Total:');
sheet.addSpan(11, 1, 7, 1);
sheet.addSpan(11, 2, 3, 1);
sheet.addSpan(14, 2, 3, 1);
sheet.addSpan(17, 2, 1, 2);
sheet.setValue(17, 2, 'Sub Total:');
sheet.addSpan(18, 1, 1, 3);
sheet.setValue(18, 1, 'Total:');
sheet.setValue(4, 1, 'NC');
sheet.setValue(4, 2, 'Raleigh');
sheet.setValue(7, 2, 'Charlotte');
sheet.setValue(4, 3, '001');
sheet.setValue(5, 3, '002');
sheet.setValue(6, 3, '003');
sheet.setValue(7, 3, '004');
sheet.setValue(8, 3, '005');
sheet.setValue(9, 3, '006');
sheet.setValue(11, 1, 'PA');
sheet.setValue(11, 2, 'Philadelphia');
sheet.setValue(14, 2, 'Pittsburgh');
sheet.setValue(11, 3, '007');
sheet.setValue(12, 3, '008');
sheet.setValue(13, 3, '009');
sheet.setValue(14, 3, '010');
sheet.setValue(15, 3, '011');
sheet.setValue(16, 3, '012');
sheet.setFormula(10, 4, '=SUM(E5:E10)');
sheet.setFormula(10, 5, '=SUM(F5:F10)');
sheet.setFormula(10, 6, '=SUM(G5:G10)');
sheet.setFormula(10, 7, '=SUM(H5:H10)');
sheet.setFormula(10, 8, '=SUM(I5:I10)');
sheet.setFormula(10, 9, '=SUM(J5:J10)');
sheet.setFormula(17, 4, '=SUM(E12:E17)');
sheet.setFormula(17, 5, '=SUM(F12:F17)');
sheet.setFormula(17, 6, '=SUM(G12:G17)');
sheet.setFormula(17, 7, '=SUM(H12:H17)');
sheet.setFormula(17, 8, '=SUM(I12:I17)');
sheet.setFormula(17, 9, '=SUM(J12:J17)');
for (let i = 0; i < 14; i++) {
sheet.setFormula(4 + i, 10, '=SUM(E' + (5 + i).toString() + ':J' + (5 + i).toString() + ')');
}
sheet.setFormula(18, 4, '=E11+E18');
sheet.setFormula(18, 5, '=F11+F18');
sheet.setFormula(18, 6, '=G11+G18');
sheet.setFormula(18, 7, '=H11+H18');
sheet.setFormula(18, 8, '=I11+I18');
sheet.setFormula(18, 9, '=J11+J18');
sheet.setFormula(18, 10, '=K11+K18');
sheet.getRange(1, 1, 3, 10).backColor('#D9D9FF');
sheet.getRange(4, 1, 15, 3).backColor('#D9FFD9');
sheet.getRange(1, 1, 3, 10).hAlign(spreadNS.HorizontalAlign.center);
sheet.getRange(1, 1, 18, 10).setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.thin), { all: true });
sheet.getRange(4, 4, 3, 6).setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), { inside: true });
sheet.getRange(7, 4, 3, 6).setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), { inside: true });
sheet
.getRange(11, 4, 3, 6)
.setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), { inside: true });
sheet
.getRange(14, 4, 3, 6)
.setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), { inside: true });
this.fillSampleData(sheet, new spreadNS.Range(4, 4, 6, 6));
this.fillSampleData(sheet, new spreadNS.Range(11, 4, 6, 6));
}
fillSampleData(sheet: GC.Spread.Sheets.Worksheet, range: GC.Spread.Sheets.Range) {
for (let i = 0; i < range.rowCount; i++) {
for (let j = 0; j < range.colCount; j++) {
sheet.setValue(range.row + i, range.col + j, Math.ceil(Math.random() * 300));
}
}
}
bindEvents (spread: GC.Spread.Sheets.Workbook) {
let sheet = spread.getSheet(0), self = this;
spread.bind(GC.Spread.Sheets.Events.SelectionChanged, function () {
self.reset();
sheet.repaint();
});
}
reset () {
let sheet = this.spread.getActiveSheet();
let activeRow = sheet.getActiveRowIndex();
let activeCol = sheet.getActiveColumnIndex();
let style = sheet.getStyle(activeRow, activeCol);
this.leftTop = false;
this.rightTop = false;
this.leftBottom = false;
this.rightBottom = false;
if (style && style.decoration && style.decoration.cornerFold) {
let cornerFold = style.decoration.cornerFold;
this.size = +cornerFold.size;
this.color = cornerFold.color;
if (cornerFold.position & 1) {
this.leftTop = true;
}
if (cornerFold.position & 2) {
this.rightTop = true;
}
if (cornerFold.position & 4) {
this.leftBottom = true;
}
if (cornerFold.position & 8) {
this.rightBottom = true;
}
} else {
this.size = 6;
this.color = null;
}
}
set () {
let sheet = this.spread.getActiveSheet();
let activeRow = sheet.getActiveRowIndex();
let activeCol = sheet.getActiveColumnIndex();
let style = sheet.getStyle(activeRow, activeCol);
if (!style) {
style = new GC.Spread.Sheets.Style();
}
let position = 0;
if (this.leftTop) {
position = position | 1;
}
if (this.rightTop) {
position = position | 2;
}
if (this.leftBottom) {
position = position | 4;
}
if (this.rightBottom) {
position = position | 8;
}
style.decoration = {
cornerFold: {
size: this.size,
position: position,
color: this.color
}
}
sheet.setStyle(activeRow, activeCol, style);
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div class="options-container">
<p>Try selecting a cell, change the following options and hit the "reset" button.</p>
<div class="corner-pro">
<label for="size-corner">corner size:</label><input type="number" id="size-corner" class="corner-input" placeholder="corner-size" [(ngModel)]="size">
</div>
<div class="corner-pro">
<label for="color-corner">corner color:</label><input type="text" id="color-corner" class="corner-input" placeholder="corner-color" [(ngModel)]="color">
</div>
<div class="corner-pro">
<label for="position-corner">leftTop position:</label><input type="checkbox" class="corner-input" id="leftTop" [(ngModel)]="leftTop">
</div>
<div class="corner-pro">
<label for="position-corner">rightTop position:</label><input type="checkbox" class="corner-input" id="rightTop" [(ngModel)]="rightTop">
</div>
<div class="corner-pro">
<label for="position-corner">leftBottom position:</label><input type="checkbox" class="corner-input" id="leftBottom" [(ngModel)]="leftBottom">
</div>
<div class="corner-pro">
<label for="position-corner">rightBottom position:</label><input type="checkbox" class="corner-input" id="rightBottom" [(ngModel)]="rightBottom">
</div>
<div class="corner-pro">
<button id="set-corner" class="corner-btn" (click)="set()">set</button>
<button id="reset-corner" class="corner-btn" (click)="reset()">reset</button>
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
label {
display: inline-block;
width: 135px;
}
.corner-pro {
width: 100%;
height: 30px;
font-size: 13px;
}
#size-corner, #color-corner {
display: inline-block;
width: 100px;
}
.corner-btn {
display: inline-block;
width: 100px;
height: 30px;
margin-left: 20px;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);